from Products.Gideon.Objects.Namespace import *
from Products.Gideon.Objects.Ratings.Ratings import Rating
from Products.Gideon.Log.Log import LogFactory
from Products.Gideon.PageContract.Scripts import compile

from util import package_admin_home

log = LogFactory('PackageAdmin')

class ApprovePresentation(SimpleItem):

    id = 'Approve'
    
    """
    
    admin ui for managing package approval
    
    """

    index_html = DTMLFile(
        'ui/PackageAdminApproveForm',
        package_admin_home)

    problem_categories_html = DTMLFile(
        'ui/PackageAdminApproveForm',
        package_admin_home)

    def edit_package_approve(self, REQUEST):
        """ """
        
        contract = """
        #parameters
        package_notes:optional, trim, nohtml
        """
        contract = compile(contract)
        contract.validate(self)

        #if REQUEST.has_key('package_notes'):
        #    package_notes = REQUEST['package_notes']
         
        #################################
        #
        # Before we approve we run through some logic checks
        # to insure that the package is ready for approval.

        pkginfo = self.get_package_info()

        categories = pkginfo.package_categories()
        if not categories:
            return self.problem_categories_html(self, REQUEST)

        #################################
        #
        # move the package from q to the public package container
        #
        
        pid = pkginfo.package_name()
        log.debug('approving package (%s) in queue'%pid)

        queue = self.get_inner_application(self)
        package = self.get_package()

        log.debug('removing package (%s) in queue'%pid)		
        queue.remove_package(package)
        
        log.debug('adding package (%s) to published packages'%pid) 
        package_container = self.get_inner_application(self, 2) 
        package_container.add_package(self.get_package())

        #################################
        #
        # record for posterity
        #
        history = package.get_history()

        # this is none if anonymous
        log.debug('adding note user currently %s'%(
             getSecurityManager().getUser().getId()
             )
            )
        history.add_note('transition',
                         'package published %s'%REQUEST['package_notes'])

        #################################
        
        # redirect back to queue
        if REQUEST is not None:
            REQUEST.RESPONSE.redirect(queue.absolute_url()+\
                                      '?message='+pid+'+published')

