from Products.Gideon.Objects.Namespace import *
from Products.Gideon.Objects.Ratings.Ratings import Rating
from Products.Gideon.Log.Log import LogFactory
from Products.Gideon.PageContract.Scripts import compile

from util import package_admin_home

class AuthorsPresentation(SimpleItem):

    """

    admin ui for managing authors

    """

    id = 'Authors'

    index_html = DTMLFile(
        'ui/PackageAdminEditAuthors',
        package_admin_home)    

    

    def package_add_author(self,
                            first_name,
                            last_name,
                            public_email,
                            homepage='',
                            REQUEST=None):
        """ 
        authors for new packages are first stored as state vars
        till the package gets published, then they get added to the 
        author container via the event channel. there after they
        get added directly to the author_container.
        """
        
        contract = """
        #parameters
        first_name:trim
        last_name:trim
        public_email:trim, email
        homepage:trim
        """
        
        contract = compile(contract, self)
        contract.validate(REQUEST)

        aid = make_author_id(first_name, last_name)
        
        if self.get_package().is_published() == 1:
            author_container = self.get_application_for_name('Authors')
            
            if author_container.get_author(aid, None) is None:

                author_container.add_author(first_name,
                                            last_name,
                                            public_email,
                                            homepage)
            else:
                
                statevars = self.get_state_vars()
                authors = statevars.get('authors', [])
                authors.append(Author(aid,
                                      first_name,
                                      last_name,
                                      public_email))
                statevars['authors']=authors
            
        REQUEST.RESPONSE.redirect('.')
        

