from Products.Gideon.Objects.Namespace import *
from Products.Gideon.Objects.Ratings.Ratings import Rating
from Products.Gideon.Log.Log import LogFactory
from Products.Gideon.PageContract.Scripts import compile
from Products.Gideon.Objects.Catalog import CatalogSchema
from Products.Gideon.Objects.Authors.Authors import Author, make_author_id

from util import package_admin_home

class CategoriesPresentation(SimpleItem):
    
    """
    
    admin ui for managing package categories
    
    """

    id = 'Categories'

    index_html = DTMLFile(
        'ui/PackageAdminEditCategories',
        package_admin_home)

    def edit_package_categories(self, REQUEST):
        """ """
        # need a constrainted list contract
        contract = """
        #parameters
        package_categories:trim
        """
        categories = REQUEST['package_categories']
        info = self.get_package_info()
        
        info.set_categories(categories)
        
        # event broadcast to listeners
        if self.get_package_info().is_published():        
            channel = self.get_service("EventChannel")
            channel.publish(self.get_package(), "package categories modified")
        
        history = self.get_package().get_history()
        history.add_note("edit", "package categories edited")
        REQUEST.RESPONSE.redirect('.')

