from Products.Gideon.Objects.Namespace import *
from Products.Gideon.Objects.Ratings.Ratings import Rating
from Products.Gideon.Log.Log import LogFactory
from Products.Gideon.PageContract.Scripts import compile
from Products.Gideon.Objects.Catalog import CatalogSchema
from Products.Gideon.Objects.Authors.Authors import Author, make_author_id

from util import package_admin_home

from Products.Gideon.Objects.Packages.PackageDependency \
     import PackageDependency

class DependenciesPresentation(SimpleItem):
    
    """
    
    admin ui for managing package dependencies
    
    """

    id = 'Dependencies'
    
    index_html = DTMLFile(
        'ui/PackageAdminEditDependenciesForm',
        package_admin_home)

    def package_add_dependency(self, REQUEST=None, **kw):
        """ """
        contract = """
        #parameters
        package_version:trim, validid
        dependency_name:trim, validid
        type:trim, constraint(supported_dependency_types)
        kind:trim, constraint(supported_dependency_kinds)
        architecture:trim, constraint(supported_architectures)
        min_version:trim
        max_version:optional, trim
        """

        # we will manually process package_version

        if REQUEST is not None:
            contract = compile(contract, self)
            contract.validate(REQUEST)
            vars = contract.extract_variables(REQUEST)
        elif kw:
            vars = kw
        else:
            raise "No Args Supplied to package add dependency"

        package = self.get_package()
        versions = package.get_version_container()

        dependency = PackageDependency(
                     vars.dependency_name,
                     vars.type,
                     vars.kind,
                     vars.architecture,
                     vars.min_version,
                     vars.max_version
                     )

        if vars.package_version == 'All':
            versions.add_global_dependency(dependency)
        else:
            version = versions.get_version(vars.package_version)
            version.add_version_dependency(dependency)
            
        history = package.get_history()
        
        history.add_note("addition", "%s dependency added"%(
            vars.dependency_name)
                         )
        
        if REQUEST:
            REQUEST.RESPONSE.redirect(
                'edit_package_dependencies_form?message=dependency+added')

    def package_remove_dependency(self,
                                  dependency_name,
                                  version_id='', 
                                  REQUEST=None
                                  ):
        """ """ 
        package = self.get_package()

        versions = package.get_version_container()

        if version_id:
            version = versions.get_version(version_id)
            version.remove_dependency(dependency_name)
        else:
            versions.remove_global_dependency(dependency_name)

        history = package.get_history()
        history.add_note("removal", "%s dependency removed"%dependency_name)

        if REQUEST:
            REQUEST.RESPONSE.redirect(
                'edit_package_dependencies_form?message=dependency+removed')
