from Products.Gideon.Objects.Namespace import *
from Products.Gideon.Objects.Ratings.Ratings import Rating
from Products.Gideon.Log.Log import LogFactory
from Products.Gideon.PageContract.Scripts import compile
from Products.Gideon.Objects.Catalog import CatalogSchema
from Products.Gideon.Objects.Authors.Authors import Author, make_author_id

from util import package_admin_home

from Products.Gideon.Objects.Packages.PackageVersion \
     import PackageVersion

from Products.Gideon.Objects.Packages.PackageFile \
     import PackageFile

class VersionsPresentation(SimpleItem):
    """
    admin ui for managing package info
    """

    id = 'Versions'

    index_html = DTMLFile(
        'ui/PackageAdminEditVersionsForm',
        package_admin_home)

    def package_create_version(self, REQUEST):
        """ create a new package version """
        contract = """
        #parameters
        version_id:trim
        """ 
        contract = compile(contract)
        contract.validate(self)
        
        version = PackageVersion(REQUEST['version_id'])
        version_container = self.get_version_container()        
        
        version_container.add_version(version)

        history = self.get_package().get_history()
        history.add_note("addition", "version added")        

        REQUEST.RESPONSE.redirect('.')

    def edit_package_versions(self, REQUEST):
        """ """

    def package_add_version_file(self, REQUEST):
        """ """
        contract = """
        #parameters
        version_file:file
        file_type:trim, constraint(supported_file_types)
        platform:trim, constraint(supported_platforms)
        """
        #version_id:trim, obid(Versions)
        
        contract = compile(contract,self)
        
        contract.validate(REQUEST)
        
        container = self.get_version_container()
        version = container._getOb(REQUEST['version_id'])
        
        id, title = cookId('','',REQUEST['version_file'])
        
        fobj= PackageFile(id, 
                          title, 
                          REQUEST['file_type'],
                          'tgz',
                          REQUEST['platform'])
        
        version.add_file(fobj)
        
        fobj = version._getOb(id)
        fobj.manage_upload(REQUEST['version_file'])
        
        history = self.get_package().get_history()
        history.add_note("addition", "file added")
        
        REQUEST.RESPONSE.redirect('.')
