from OFS.Image import cookId

from Products.Gideon.Objects.Namespace import *
from Products.Gideon.Objects.Ratings.Ratings import Rating
from Products.Gideon.Log.Log import LogFactory
from Products.Gideon.PageContract.Scripts import compile
from Products.Gideon.Objects.Catalog import CatalogSchema
from Products.Gideon.Objects.Authors.Authors import Author, make_author_id

from PackageFile import PackageFile
from PackageVersion import PackageVersionContainer, PackageVersion
from PackageHistory import PackageHistory
from PackageStateVariables import PackageStateVariables

import Admin
log = LogFactory('Package Admin')

admin_presentations  = {
        'Approve':Admin.ApprovePresentation(),
        'Authors':Admin.AuthorsPresentation(),
        'Categories':Admin.CategoriesPresentation(),
        'Dependencies':Admin.DependenciesPresentation(),        
        'Info':Admin.InfoPresentation(),
        'Versions':Admin.VersionsPresentation(),
        'Bar':Admin.InfoPresentation()
    }

class PackageAdmin(SimpleItem, Implicit):
    
    """
    Adminstrative Views and logic for manipulation
    of state.
    """
    security = ClassSecurityInfo()

    security.declareObjectProtected('View Package Admin')

    security.declareProtected('View Package Admin', 'index_html')
    index_html = DTMLFile('ui/PackageAdminView', globals())

    security.declareProtected('View Package Admin','view_package_history')
    view_package_history = DTMLFile('ui/PackageHistoryView', globals())
    
    ## state based widgets
    _widget_for_queue = DTMLFile('ui/PackageAdminQueueWidget',globals())
    
    _widget_for_published = \
                        DTMLFile('ui/PackageAdminPublishedWidget',globals())
    
    _menu_for_published = DTMLFile('ui/PackageAdminPublishedMenu',globals())
    
    def __init__(self,
                 id = 'Admin'
            ):
        self.id = id
        self._state = ''

    security.declarePublic('get_admin_widget')
    def get_admin_widget(self):
        """this gets called from the package view """
        package = self.get_package()
        if package._published:
            return self._widget_for_published(self, self.REQUEST)
        else:
            return self._widget_for_queue(self, self.REQUEST)
        
    security.declarePublic('get_admin_widget')
    def get_admin_menu(self):
        """ this gets called from the admin view """
        if self.get_package().is_published():
            return self._menu_for_published(self, self.REQUEST)
        else:
            return self._widget_for_queue(self, self.REQUEST)            

    def __bobo_traverse__(self, REQUEST, name):
        """ """
        view = admin_presentations.get(name, None)
        if view: 
	    wrapper = view.__of__(self)
            return wrapper
        return getattr(self, name)
        


InitializeClass(PackageAdmin)
